//   ,   (  )
//   
// +     
// +     , ,   
//
// (c) Proteus   lawnmower-man@mail.ru  icq:133575351

#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define SIZE 10000	//!<    


// h -  = -1 -  
// value - 
// p1,p2   
// tree[p1].value < tree[p2].value
struct node_st{ node_st *p1,*p2,*p; int value; int h;}; //!<  

node_st *tree_root=0;	//!< 

inline int max(int a,int b) {return a>b?a:b;}

#define ERROR_BALANCE	-1	//!<  
#define ERROR_H			-2	//!<   
#define ERROR_RELATIONS	-3	//!<   
#define ERROR_PARENT	-4	//!<    

void Clear();
node_st* Rotate12(node_st*,bool sub);
node_st* Rotate21(node_st*,bool sub);


//   (     )
int turn_count;		//!<     
int max_count;		//!<     
int sum_count;		//!<   
int sum_divider;	//!<  ,   

//=====  ! ========================

//!   
node_st* NewItem(int value)
{
	node_st *node=new node_st;
	node->value=value;
	node->p1=node->p2=node->p=0;
	node->h=1;
	return node;
}

//!  
void DelItem(node_st *node)
{
	delete node;
}

//!    
void Clear()
{
	node_st *t;
	if(!tree_root) return;
	while(tree_root->p1 || tree_root->p2) 
		if(tree_root->p2) t=tree_root->p2,tree_root->p2=t->p1,t->p1=tree_root,tree_root=t;
		else t=tree_root,tree_root=tree_root->p1,DelItem(t);
	DelItem(tree_root);
	tree_root=0;
}


//!  ,  
//! \param node 
//! \param depth 
//! \param dir   
//! \code Show(root,0,'*'); \endcode
void Show(node_st *node,int depth,char dir)
{
	int n;
	if(!node) return;
	for(n=0; n<depth; n++) putchar(' ');
	printf("%c[%d] (%d)\n",dir,node->value,node->h);
	Show(node->p1,depth+1,'-');
	Show(node->p2,depth+1,'+');
}

//!   
void SetH(node_st *node)
{
	int h1,h2; node_st *t;
	h1=h2=0;
	t=node->p1; if(t) h1=t->h;
	t=node->p2; if(t) h2=t->h;
	node->h=max(h1,h2)+1;
}


//!  
//! \param node 
//! \param sub     ,   
//! \result   
node_st *Rotate21(node_st *node,bool sub)
{
	node_st *i2=node->p2;
	node_st *i21=i2->p1;
	node_st *i22=i2->p2;
	int h22=i22?i22->h:0;
	if(sub && i21 && h22<i21->h) {
		i2=node->p2=Rotate12(i2,false);
		i2->p=node;
		i21=i2->p1;
	}
	i2->p1=node;  node->p=i2;
	node->p2=i21; if(i21) i21->p=node;
	SetH(node);
	return i2;
}

//!  
//! \param node 
//! \param sub     ,   
//! \result   
node_st *Rotate12(node_st *node,bool sub)
{
	node_st *i1=node->p1;
	node_st *i11=i1->p1;
	node_st *i12=i1->p2;
	int h11=i11?i11->h:0;
	if(sub && i12 && h11<i12->h) {
		i1=node->p1=Rotate21(i1,false);
		i1->p=node;
		i12=i1->p2;
	}
	i1->p2=node;  node->p=i1;
	node->p1=i12; if(i12) i12->p=node;
	SetH(node);
	return i1;
}

//!    
//! \result true   
bool Balance(node_st **root)
{
	bool ok=false;
	int r=0; node_st *t; int h1,h2;
	node_st *node=*root; 
	t=node->p1; h1=t?t->h:0;
	t=node->p2; h2=t?t->h:0;
	if(abs(h1-h2)>1) {
		t=node->p;
		if(h1<h2) *root=Rotate21(node,true);
		if(h1>h2) *root=Rotate12(node,true);
		(*root)->p=t;
		turn_count++;
		ok=true;
	}
	SetH(*root);
	return ok;
}

//!      
//! \param node         (  ,    )
//! \param single  true        
void BalanceAll(node_st *t,bool single)
{
	node_st *node,**root;
	while(t) {
		node=t;
		t=t->p;
		if(t) root=t->p1==node?&t->p1:&t->p2; else root=&tree_root;
		if(Balance(root) && single) break;
	}
}


//!   
//! \result true      
bool Insert(int value,node_st **root)
{
	node_st *node,*up=0;
	for(;;) {
		node=*root; if(!node) break;
		if(value==node->value) return true;
		root=value<node->value?&node->p1:&node->p2;
		up=node;
	}
	*root=NewItem(value);
	(*root)->p=up;
	BalanceAll(up,true);
	return false;
}


//!      
node_st* GetMin(node_st **root)
{
	node_st *node;
	for(;;) {
		node=*root;
		if(!node->p1) break;
		root=&node->p1;
	}
	*root=node->p2;
	if(*root) (*root)->p=node->p;
	return node;
}



//!   
//! \result false     
bool Remove(node_st **root,int value)
{
	node_st *node,*up,*temp;
	//   
	for(;;) {
		node=*root;
		if(!node) return false;
		if(node->value==value) break;
		root=node->value>value?&node->p1:&node->p2;
	}
	// 
	if(!node->p2) {		//     ,      (p1  ,     )
		*root=node->p1;	// 
		if(*root) {
			(*root)->p=node->p;
			up=(*root)->p;  //       
		} else up=node->p;
	} else {			//  ,        
		temp=*root=GetMin(&node->p2);	//      
		up=temp->p;				//      
		if(up==node) up=temp;	//         
		temp->p=node->p;		//      
		temp->p1=node->p1;
		temp->p2=node->p2;
		if(node->p1) node->p1->p=temp;
		if(node->p2) node->p2->p=temp;
	}
	DelItem(node);
	BalanceAll(up,false);
	return true;
}


//=====     ! ===============

//!  
void Show()
{
	printf("[tree]\n");
	Show(tree_root,0,'*');
}

//!  
//! \result =true   
bool Insert(int value)
{
	turn_count=0;
	if(Insert(value,&tree_root)) return false;
	if(max_count<turn_count) max_count=turn_count;
	sum_count+=turn_count; sum_divider++;
	return true;
}

//!<  
//! \result =true   
bool Remove(int value)
{
	turn_count=0;
	if(!Remove(&tree_root,value)) return false;
	if(max_count<turn_count) max_count=turn_count;
	sum_count+=turn_count; sum_divider++;
	return true;
}


//===== ! ==================================

//!   
//! \result  
int Check(node_st *node)
{
	int h1=0,h2=0,h=0; node_st *t;
	t=node->p1; if(t) {
		h1=Check(t); 
		if(t->p!=node) 
			return ERROR_PARENT;
		if(h1<0) return h1; 
		if(node->value<=t->value) return ERROR_RELATIONS;
	}
	t=node->p2; if(t) {
		h2=Check(t); 
		if(t->p!=node) 
			return ERROR_PARENT;
		if(h2<0) return h2;
		if(node->value>=t->value) return ERROR_RELATIONS;
	}
	if(abs(h1-h2)>1) return ERROR_BALANCE;
	h=(h1>h2?h1:h2)+1;
	if(h!=node->h) return ERROR_H;
	return h;
}

//!       
//! \param list  
//! \param index   
//! \param root   
void TreeWalk(int *list,int *index,node_st *root)
{
	if(!root) return;
	TreeWalk(list,index,root->p1);
	list[*index]=root->value; (*index)++;
	TreeWalk(list,index,root->p2);
}

//!    
//! \param list1 
//! \param root  
//! \result   , -1   
int Compare(int *list1,int size,node_st *root)
{
	int n,m,t; int *list2=0;
	for(n=0; n<size; n++) for(m=n+1; m<size; m++) {	// 
		if(list1[n]>list1[m]) t=list1[n],list1[n]=list1[m],list1[m]=t;
	}
	list2=new int[size+1]; 
	n=0; TreeWalk(list2,&n,tree_root);
	for(n=0; n<size; n++) {if(list1[n]!=list2[n]) return n;}
	delete[]list2;
	return -1;
}


//!    
void Stat()
{
	int n=Check(tree_root);
	printf("check value: ");
	switch(n) {
	case ERROR_BALANCE:   printf("error balance\n\a");   break;
	case ERROR_H:		  printf("error h\n\a");         break;
	case ERROR_RELATIONS: printf("error relations\n\a"); break;
	case ERROR_PARENT:    printf("error parent\n\a");    break;
	default: printf("OK (%d)\n",n); break;
	}	
	printf("max turn count: %d\n",max_count);
	printf("average turn count: %f\n",sum_divider?(double)sum_count/sum_divider:1);
}

//!  
void ResetStat()
{
	max_count=sum_count=sum_divider=0;
}



//!    
void main()
{
	srand(clock());
	int array[SIZE+1]; int n,m,count,v;
	ResetStat();
	printf("=== insert\n");
	for(n=count=0; n<SIZE; n++) {
		v=rand()%(SIZE+SIZE/2);
		if(Insert(v)) array[count++]=v;
	}
	printf("nodes: %d\n",count);
	Stat();
	ResetStat();
	printf("=== remove\n");
	for(n=0; n<SIZE/2; n++) {
		m=rand()%count; v=array[m]; if(!v) continue;
		array[m]=-1; Remove(v);
	}
	for(n=m=0; n<count; n++) { //  ,   
		if(array[n]>=0) array[m++]=array[n];
	}
	count=m;
	printf("nodes: %d\n",count);
	Stat();
	ResetStat();
	n=Compare(array,count,tree_root);
	if(n<0) printf("Check Nodes: ok\n"); else printf("Internal error [%d]\n\a",n);
	Clear();
	printf("[press enter]\n");
	getchar();
}




